// QuickYellow.com | Javascript for Mac Dashboard Widget
// Copyright 2009. Brett Somsen at IDC Networks, Inc.
// Version 1.0 - Created on May 1, 2009

function load() // Called by HTML body element's onload event when widget is ready to roll
{
    dashcode.setupParts(); 
    if (widget.preferenceForKey("prefWhere") != undefined) { // Set the where field if there is one already defined (saves last where input)
        document.getElementById("fWhere").value = widget.preferenceForKey("prefWhere");
    }
}


function remove() // Called when the widget has been removed from the Dashboard
{
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

function hide() // Called when the widget has been hidden
{
    // Stop any timers to prevent CPU usage
}

function show() // Called when the widget has been shown
{
    // Restart any timers that were stopped on hide
}

function sync() // Called when the widget has been synchronized with .Mac
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}


function showBack(event) // Called when the info button is clicked to show the back of the widget
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

function showFront(event) // Called when the done button is clicked from the back of the widget
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function goToQuickYellowHome() // Go to the QuickYellow homepage.
{
    widget.openURL("http://quickyellow.com");
}

function goToPrivacyPolicy() // Go to the QuickYellow Privacy Policy page
{
    widget.openURL("http://quickyellow.com/privacy-policy");
}

function goToTermsOfUse() // Go to the QuickYellow Terms of Use page
{
    widget.openURL("http://quickyellow.com/terms-of-use");
}

function onButtonMouseOver(event) // Set the hover effect for the search button
{
    fButton.src = "Images/button_active.png";
}

function onButtonMouseOut(event) // De-activate hover effect for search button
{
    fButton.src = "Images/button.png";
}

function goFindMyResults(event) { // Validate, set preference and process the search
    var fWhat = document.getElementById("fWhat");
    var fWhatMsg = document.getElementById("fWhatMsg");
    var fWhere = document.getElementById("fWhere");
    var fWhereMsg = document.getElementById("fWhereMsg");
	if ((fWhat.value == "")||(fWhat.value==null)) {
        fWhatMsg.style.visibility = "visible";fWhat.focus();return false;} // check if what data is entered
    if ((fWhere.value == "")||(fWhere.value==null)) {
        fWhereMsg.style.visibility = "visible";fWhere.focus();return false;} // check if what data is entered
    widget.setPreferenceForKey(fWhere.value, "prefWhere"); // Set where preference to remember for next time
	return goToQuickYellow(fWhat, fWhere);
}


function goToQuickYellow(fWhat, fWhere) {  // Jumps you to the QuickYellow site to process search parameters.
	var urlstring = "http://quickyellow.com/goto/what/" + escape(fWhat.value) + "/where/" + escape(fWhere.value) + "/resource/wdgt-mac";
	widget.openURL(urlstring);
}

function setWhatFocus(event) { // Sets the focus of the WHAT and hides validation
    var fWhat = document.getElementById("fWhat");
    var fWhatMsg = document.getElementById("fWhatMsg");
    fWhatMsg.style.visibility = "hidden";
    fWhat.focus();fWhat.select();
}

function setWhereFocus(event) { // Sets the focus of the WHERE and hides validation
    var fWhere = document.getElementById("fWhere");
    var fWhereMsg = document.getElementById("fWhereMsg");
    fWhereMsg.style.visibility = "hidden";
    fWhere.focus();fWhere.select();
}

function onBackMouseOver(event) { // Do a small color hover effect with BACK button on back page.
    document.getElementById("fBack").style.color = "black";
}

function onBackMouseOut(event) { // Reset the original color for the BACK button on back page.
    document.getElementById("fBack").style.color = "#363636";
}

function onEnterCheck(event) { // Checks to see if user hit enter on their keyboard - if so run goFindMyResults() function
    document.getElementById("fWhatMsg").style.visibility = "hidden"; 
    document.getElementById("fWhereMsg").style.visibility = "hidden"; 
    if (event.keyCode == 13) {goFindMyResults(event); }
}